/**
 * ----------------------------------------------------------------------------------
 *
 * Copyright (C) 2009 runlevel3 GmbH
 *
 * ----------------------------------------------------------------------------------
 *
 * LICENSE:
 *
 * This file is part of CyberClockControl.
 *
 * CyberClockControl is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * CyberClockControl is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with CyberClockControl; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *
 * ----------------------------------------------------------------------------------
 *
 * Qt Creator / Qt 4.5.0
 *
 * ----------------------------------------------------------------------------------
 *
 * @copyright 2009 runlevel3 GmbH
 * @license   http://www.gnu.org/licenses/gpl.txt GNU General Public License v2
 * @link      http://www.runlevel3.de runlevel3
 **/


#ifndef I2C_USB_H
#define I2C_USB_H

#include "ui_mainwindow.h"



// cy22150 chip address
#define CY22150_ADDR  0x69

#define USB_CTRL_IN    (USB_TYPE_CLASS | USB_ENDPOINT_IN)
#define USB_CTRL_OUT   (USB_TYPE_CLASS)

// vendor and product id by ftdi
#define I2C_TINY_USB_VID  0x0403
#define I2C_TINY_USB_PID  0xc631

#define I2C_M_RD            0x01

// USB commands, must match command ids in firmware
#define CMD_ECHO       0
#define CMD_GET_FUNC   1
#define CMD_SET_DELAY  2
#define CMD_GET_STATUS 3
#define CMD_I2C_IO     4
#define CMD_I2C_BEGIN  1  // flag to I2C_IO
#define CMD_I2C_END    2  // flag to I2C_IO

#define STATUS_IDLE          0
#define STATUS_ADDRESS_ACK   1
#define STATUS_ADDRESS_NAK   2


void do_usb_ui_init(Ui::MainWindow *_ui);
void do_usb_error_display();
int do_usb_scan();
int do_usb_open();
int do_usb_close();

int i2c_read_multi(unsigned char chip_addr, char start_addr, int length, char *result);
int i2c_write_addr(unsigned char chip_addr, char data);
int i2c_write_byte(unsigned char chip_addr, char start_addr, char buffer);


#endif // I2C_USB_H
